︠d1ede69b-81a5-43e7-b4f3-f9541bf21002︠
%md
# Math 152: Intro to Mathematical Software
### 2017-03-06
### Kiran Kedlaya; University of California, San Diego
### adapted from lectures by William Stein, University of Washington

### ** Lecture 23: SciPy: Additional tools for scientific computation **
︡e78f2852-deee-428c-9532-38ee4620daad︡{"done":true,"md":"# Math 152: Intro to Mathematical Software\n### 2017-03-06\n### Kiran Kedlaya; University of California, San Diego\n### adapted from lectures by William Stein, University of Washington\n\n### ** Lecture 23: SciPy: Additional tools for scientific computation **"}
︠77c80c2f-ecdf-4103-ab71-10d129fd885fi︠
%md

Announcements:

- This week's schedule is as usual: homework is due Tuesday at 8pm; peer review due Thursday at 8pm; sections and office hours meet as scheduled.
- However, *next week*'s schedule will be modified because Peter and Zonglin and I will all be at a conference for part of the week.
   * The last homework will be due Friday, March 17 at 8pm. Peer review will be due Sunday, March 19 at 8pm.
   * Sections will not be held on Monday, March 13.
   * Office hours will be rescheduled for Thursday and Friday. The exact times will be announced later this week.
   * There will be guest lecturers on Monday and Wednesday. Details to be announced later.
- The window for course evaluations (CAPE) is open! Your detailed feedback will be greatly appreciated, and will help the math department with future course design.
︡62f7fd25-893f-4046-8a1d-15e22a7b468a︡{"done":true,"md":"\nAnnouncements:\n\n- This week's schedule is as usual: homework is due Tuesday at 8pm; peer review due Thursday at 8pm; sections and office hours meet as scheduled.\n- However, *next week*'s schedule will be modified because Peter and Zonglin and I will all be at a conference for part of the week.\n   * The last homework will be due Friday, March 17 at 8pm. Peer review will be due Sunday, March 19 at 8pm.\n   * Sections will not be held on Monday, March 13.\n   * Office hours will be rescheduled for Thursday and Friday. The exact times will be announced later this week.\n   * There will be guest lecturers on Monday and Wednesday. Details to be announced later.\n- The window for course evaluations (CAPE) is open! Your detailed feedback will be greatly appreciated, and will help the math department with future course design."}
︠1ecc913e-a09a-4fce-b08b-3aac273baa0bi︠
%md
Plan for the rest of the course:

- Today: finish the unit on scientific computation by demonstrating some additional functionality provide by SciPy. We will loosely follow the [SciPy Tutorial](https://docs.scipy.org/doc/scipy/reference/tutorial/index.html).
- Rest of this week: abstract algebra and number theory.
- Next week: cryptography (including a preview of Math 187B, which will also use SageMathCloud).
︡499d530f-8192-4ced-bf7e-dd0ee9b5f2cb︡{"done":true,"md":"Plan for the rest of the course:\n\n- Today: finish the unit on scientific computation by demonstrating some additional functionality provide by SciPy. We will loosely follow the [SciPy Tutorial](https://docs.scipy.org/doc/scipy/reference/tutorial/index.html).\n- Rest of this week: abstract algebra and number theory.\n- Next week: cryptography (including a preview of Math 187B, which will also use SageMathCloud)."}
︠dd04399a-a613-4e1f-bc09-e0a093252088i︠
%md
## Special functions
︡53da9397-4c4f-45a7-b446-0cad9ee8cea8︡{"done":true,"md":"## Special functions"}
︠b7fe2baf-d649-4a81-b4f2-4b498747dba2i︠
%md

In addition to the basic functions you encounter in calculus (trig functions, exponential/logarithm), mathematicians have isolated a number of other *special functions* that occur from time to time, often when solving differential equations. See [this list](https://docs.scipy.org/doc/scipy/reference/special.html#module-scipy.special).
︡2de6574c-2d35-4e59-b6bf-acc553612353︡{"done":true,"md":"\nIn addition to the basic functions you encounter in calculus (trig functions, exponential/logarithm), mathematicians have isolated a number of other *special functions* that occur from time to time, often when solving differential equations. See [this list](https://docs.scipy.org/doc/scipy/reference/special.html#module-scipy.special)."}
︠c6050fd5-cb24-47e4-8a99-5f2c7e06b292s︠
special.jn_zeros?
︡d8ffb9d4-3345-49e0-be40-aab08823f7c8︡{"code":{"lineno":-1,"mode":"text/x-rst","source":"File: /projects/sage/sage-7.5/local/lib/python2.7/site-packages/scipy/special/basic.py\nSignature : special.jn_zeros()\nDocstring :\nCompute zeros of integer-order Bessel function Jn(x).\n\nn : int\n   Order of Bessel function\n\nnt : int\n   Number of zeros to return\n\n[1] Zhang, Shanjie and Jin, Jianming. \"Computation of Special\n    Functions\", John Wiley and Sons, 1996, chapter 5.\n    http://jin.ece.illinois.edu/specfunc.html"}}︡{"done":true}
︠15494d8d-c866-4a20-a295-bd671282d496s︠
## Example: Bessel functions, used to calculate vibrational modes of a circular drum
%python
import numpy as np
from scipy import special

def drumhead_height(n, k, distance, angle, t):
   kth_zero = special.jn_zeros(n, k)[-1]
   return np.cos(t) * np.cos(n*angle) * special.jn(n, distance*kth_zero)
theta = np.r_[0:2*np.pi:50j]
radius = np.r_[0:1:50j]
x = np.array([r * np.cos(theta) for r in radius])
y = np.array([r * np.sin(theta) for r in radius])
z = np.array([drumhead_height(3, 1, r, theta, 0.5) for r in radius])
︡5f608ece-a187-4f21-bdeb-58ae2c75c689︡
︠18affe17-4ccf-4013-be3d-7c1b8cbc5ee9sw︠
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D
from matplotlib import cm
fig = plt.figure()
ax = Axes3D(fig)
ax.plot_surface(x, y, z, rstride=1, cstride=1, cmap=cm.jet)
ax.set_xlabel('X')
ax.set_ylabel('Y')
ax.set_zlabel('Z')
plt.show()
︡11af99e8-4c9f-4337-9183-223c0d3928e0︡{"stdout":"<mpl_toolkits.mplot3d.art3d.Poly3DCollection object at 0x7fa9ec9827d0>"}︡{"stdout":"\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fa9ec985b90>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fa9e6e096d0>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fa9e6d47a50>\n"}︡{"file":{"filename":"67457344-ce67-46e8-bef3-76378e86fa85.svg","show":true,"uuid":"375dd0a4-6976-4aed-9b98-40e3f4341b57"},"once":false}︡{"done":true}
︠7ec024c9-eef3-47af-926d-2c0db14127b2s︠
## The error function, i.e., the integral of a Gaussian normal distribution.
x = np.linspace(-3, 3)
plt.plot(x, special.erf(x))
plt.xlabel('$x$')
plt.ylabel('$erf(x)$')
plt.show()
︡41874545-f040-4eb0-90dc-36fb8a002272︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7fa9e6b03590>]\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fa9ec9bbb10>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7fa9ec9d6750>\n"}︡{"file":{"filename":"5543713d-5bbb-428c-949e-8dc778976650.svg","show":true,"uuid":"4c55805c-7df0-4ca0-a547-86b47223623f"},"once":false}︡{"done":true}
︠1307fe66-5511-45a0-89e0-36ea965a8739s︠
## This one is available in Sage also.
plot(erf, (-3,3))
︡9f93a650-dfe7-402d-af24-ec5a212d1224︡{"file":{"filename":"/projects/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/.sage/temp/compute5-us/19672/tmp_pUOQLb.svg","show":true,"uuid":"259629f9-aac7-4e36-9316-495230aa943b"},"once":false}︡{"done":true}
︠c3ce6250-90e8-450f-8bab-2a865b4dea50i︠
%md 
## Integration
︡95af60c3-ba49-46ae-a1c4-41bd946e614a︡{"done":true,"md":"## Integration"}
︠d1a8c6b9-d46b-4666-a34a-b1177212a0abi︠
%md

In case you need something more sophisticated than Sage's built-in numerical integration, some options can be found [here](https://docs.scipy.org/doc/scipy/reference/tutorial/integrate.html). Here I'll demonstrate one example: numerically solving an ordinary differential equation (ODE).
︡23566e29-22d1-4be4-adfc-f6ae1504f8f5︡{"done":true,"md":"\nIn case you need something more sophisticated than Sage's built-in numerical integration, some options can be found [here](https://docs.scipy.org/doc/scipy/reference/tutorial/integrate.html). Here I'll demonstrate one example: numerically solving an ordinary differential equation (ODE)."}
︠0feb6365-a569-4060-9e4d-307deaf566e5i︠
%md
Consider the second-order equation
\[\frac{d^{2}w}{dz^{2}}-zw(z)=0\]
with initial conditions \(w\left(0\right)=\frac{1}{\sqrt[3]{3^{2}}\Gamma\left(\frac{2}{3}\right)}\) and \(\left.\frac{dw}{dz}\right|_{z=0}=-\frac{1}{\sqrt[3]{3}\Gamma\left(\frac{1}{3}\right)}.\) It is known that the solution to this differential equation with these boundary conditions is the Airy function
\[w=\textrm{Ai}\left(z\right);\]
let us compare the numerical result against the SciPy function `special.airy`.
︡162a781a-da2d-4c9e-8976-a1a6ef8f7a9c︡{"done":true,"md":"Consider the second-order equation\n\\[\\frac{d^{2}w}{dz^{2}}-zw(z)=0\\]\nwith initial conditions \\(w\\left(0\\right)=\\frac{1}{\\sqrt[3]{3^{2}}\\Gamma\\left(\\frac{2}{3}\\right)}\\) and \\(\\left.\\frac{dw}{dz}\\right|_{z=0}=-\\frac{1}{\\sqrt[3]{3}\\Gamma\\left(\\frac{1}{3}\\right)}.\\) It is known that the solution to this differential equation with these boundary conditions is the Airy function\n\\[w=\\textrm{Ai}\\left(z\\right);\\]\nlet us compare the numerical result against the SciPy function `special.airy`."}
︠22b2117f-3d88-405c-8d28-0b8e84a2d2a1i︠
%md
To use the SciPy solve, we must first convert this ODE into a first-order system by setting \(\mathbf{y}=\left[\frac{dw}{dz},w\right]\) and \(t=z\). Thus, the differential equation becomes
\[\begin{split}\frac{d\mathbf{y}}{dt}=\left[\begin{array}{c} ty_{1}\\ y_{0}\end{array}\right]=\left[\begin{array}{cc} 0 & t\\ 1 & 0\end{array}\right]\left[\begin{array}{c} y_{0}\\ y_{1}\end{array}\right]=\left[\begin{array}{cc} 0 & t\\ 1 & 0\end{array}\right]\mathbf{y}.\end{split}\]

In other words,
\[\mathbf{f}\left(\mathbf{y},t\right)=\mathbf{A}\left(t\right)\mathbf{y}.\]
︡a16fb737-e062-4354-a490-b26b92401daa︡{"done":true,"md":"To use the SciPy solve, we must first convert this ODE into a first-order system by setting \\(\\mathbf{y}=\\left[\\frac{dw}{dz},w\\right]\\) and \\(t=z\\). Thus, the differential equation becomes\n\\[\\begin{split}\\frac{d\\mathbf{y}}{dt}=\\left[\\begin{array}{c} ty_{1}\\\\ y_{0}\\end{array}\\right]=\\left[\\begin{array}{cc} 0 & t\\\\ 1 & 0\\end{array}\\right]\\left[\\begin{array}{c} y_{0}\\\\ y_{1}\\end{array}\\right]=\\left[\\begin{array}{cc} 0 & t\\\\ 1 & 0\\end{array}\\right]\\mathbf{y}.\\end{split}\\]\n\nIn other words,\n\\[\\mathbf{f}\\left(\\mathbf{y},t\\right)=\\mathbf{A}\\left(t\\right)\\mathbf{y}.\\]"}
︠d631475d-e1aa-4d6e-912b-b8360fa655aai︠
%md
The required inputs to `odeint` are the function defining the derivative, `fprime`; the initial conditions vector, `y0`; and the evaluation points at which to obtain a solution, `t` (with the initial value point as the first element of this sequence). The output is a matrix where each row contains the solution vector at each requested evaluation point (the initial conditions are given in the first output row).
︡3053568f-1f41-4981-9ac5-6b15f2c68b4d︡{"done":true,"md":"The required inputs to `odeint` are the function defining the derivative, `fprime`; the initial conditions vector, `y0`; and the evaluation points at which to obtain a solution, `t` (with the initial value point as the first element of this sequence). The output is a matrix where each row contains the solution vector at each requested evaluation point (the initial conditions are given in the first output row)."}
︠59f4b705-ea94-4e19-b495-dc94b4fabe33s︠
%python3
from scipy.integrate import odeint
from scipy.special import gamma, airy
y1_0 = 1.0 / 3**(2.0/3.0) / gamma(2.0/3.0)
y0_0 = -1.0 / 3**(1.0/3.0) / gamma(1.0/3.0)
y0 = [y0_0, y1_0]
def func(y, t):
    return [t*y[1],y[0]]

def gradient(y, t):
    return [[0,t], [1,0]]

x = np.arange(0, 4.0, 0.01)
t = x
ychk = airy(x)[0]
y = odeint(func, y0, t)
y2 = odeint(func, y0, t, Dfun=gradient)
︡7fedbe56-a470-4279-ae78-b3e8ce4e7945︡{"done":true}
︠51472233-e3e1-46fa-9f66-c7f62029119es︠
ychk[:36:6] ## values computed using the built-in Airy function
︡3ed07e05-9b39-4c05-a8bf-04ac9771cd3b︡{"stdout":"array([ 0.35502805,  0.33951139,  0.32406751,  0.30876307,  0.29365818,\n        0.27880648])\n"}︡{"done":true}
︠c61dd5e4-8940-4247-8bbc-a8e4d73c620fs︠
%python3
import matplotlib.pyplot as plt
plt.figure()
plt.plot(x, y[:, 1])
plt.show()
︡958c6018-ab89-4d62-bda6-f76744a92314︡{"file":{"filename":"/tmp/tmpbGYJl9.png","show":true,"uuid":"1e9af6bb-c613-4b7c-abf0-dce13c5dd891"},"once":false}︡{"done":true}
︠8dbf83ed-edf8-4967-a7c7-cbf512a44174s︠
y[:36:6,1] ## values computed using odeint
︡37d3ab3b-a760-4c2e-a88a-6c45a6926f37︡{"stdout":"array([ 0.35502805,  0.33951138,  0.32406749,  0.30876306,  0.29365817,\n        0.27880648])\n"}︡{"done":true}
︠510e740d-da1b-4773-861a-67468a2a3debs︠
y2[:36:6,1] ## values computed using odeint with user-specified gradient
︡34ab1bb3-6e4f-4963-91a4-059248a8780b︡{"stdout":"array([ 0.35502805,  0.33951138,  0.32406749,  0.30876306,  0.29365817,\n        0.27880648])\n"}︡{"done":true}
︠1985c0c8-9ce3-4137-a0ab-e0de192e0864s︠
odeint?
︡b6f1f6fb-45f2-4533-ab27-4d94562c7596︡{"code":{"lineno":-1,"mode":"text/x-rst","source":"File: /projects/sage/sage-7.5/local/lib/python2.7/site-packages/scipy/integrate/odepack.py\nSignature : odeint(func, y0, t, args=(), Dfun=None, col_deriv=0, full_output=0, ml=None, mu=None, rtol=None, atol=None, tcrit=None, h0=0.0, hmax=0.0, hmin=0.0, ixpr=0, mxstep=0, mxhnil=0, mxordn=12, mxords=5, printmessg=0)\nDocstring :\nIntegrate a system of ordinary differential equations.\n\nSolve a system of ordinary differential equations using lsoda from\nthe FORTRAN library odepack.\n\nSolves the initial value problem for stiff or non-stiff systems of\nfirst order ode-s:\n\n   dy/dt = func(y, t0, ...)\n\nwhere y can be a vector.\n\n*Note*: The first two arguments of \"func(y, t0, ...)\" are in the\nopposite order of the arguments in the system definition function\nused by the scipy.integrate.ode class.\n\nfunc : callable(y, t0, ...)\n   Computes the derivative of y at t0.\n\ny0 : array\n   Initial condition on y (can be a vector).\n\nt : array\n   A sequence of time points for which to solve for y.  The initial\n   value point should be the first element of this sequence.\n\nargs : tuple, optional\n   Extra arguments to pass to function.\n\nDfun : callable(y, t0, ...)\n   Gradient (Jacobian) of func.\n\ncol_deriv : bool, optional\n   True if Dfun defines derivatives down columns (faster),\n   otherwise Dfun should define derivatives across rows.\n\nfull_output : bool, optional\n   True if to return a dictionary of optional outputs as the second\n   output\n\nprintmessg : bool, optional\n   Whether to print the convergence message\n\ny : array, shape (len(t), len(y0))\n   Array containing the value of y for each desired time in t, with\n   the initial value y0 in the first row.\n\ninfodict : dict, only returned if full_output == True\n   Dictionary containing additional output information\n\n   +---------+--------------------------------------------------------------+\n   | key     | meaning                                                      |\n   +=========+==============================================================+\n   | 'hu'    | vector of step sizes successfully used for each time step.   |\n   +---------+--------------------------------------------------------------+\n   | 'tcur'  | vector with the value of t reached for each time step. (will |\n   |         | always be at least as large as the input times).             |\n   +---------+--------------------------------------------------------------+\n   | 'tolsf' | vector of tolerance scale factors, greater than 1.0,         |\n   |         | computed when a request for too much accuracy was detected.  |\n   +---------+--------------------------------------------------------------+\n   | 'tsw'   | value of t at the time of the last method switch (given for  |\n   |         | each time step)                                              |\n   +---------+--------------------------------------------------------------+\n   | 'nst'   | cumulative number of time steps                              |\n   +---------+--------------------------------------------------------------+\n   | 'nfe'   | cumulative number of function evaluations for each time step |\n   +---------+--------------------------------------------------------------+\n   | 'nje'   | cumulative number of jacobian evaluations for each time step |\n   +---------+--------------------------------------------------------------+\n   | 'nqu'   | a vector of method orders for each successful step.          |\n   +---------+--------------------------------------------------------------+\n   | 'imxer' | index of the component of largest magnitude in the weighted  |\n   |         | local error vector (e / ewt) on an error return, -1          |\n   |         | otherwise.                                                   |\n   +---------+--------------------------------------------------------------+\n   | 'lenrw' | the length of the double work array required.                |\n   +---------+--------------------------------------------------------------+\n   | 'leniw' | the length of integer work array required.                   |\n   +---------+--------------------------------------------------------------+\n   | 'mused' | a vector of method indicators for each successful time step: |\n   |         | 1: adams (nonstiff), 2: bdf (stiff)                          |\n   +---------+--------------------------------------------------------------+\n\nml, mu : int, optional\n   If either of these are not None or non-negative, then the\n   Jacobian is assumed to be banded.  These give the number of\n   lower and upper non-zero diagonals in this banded matrix. For\n   the banded case, Dfun should return a matrix whose rows contain\n   the non-zero bands (starting with the lowest diagonal). Thus,\n   the return matrix jac from Dfun should have shape \"(ml + mu + 1,\n   len(y0))\" when \"ml >=0\" or \"mu >=0\". The data in jac must be\n   stored such that \"jac[i - j + mu, j]\" holds the derivative of\n   the i`th equation with respect to the `j`th state variable.  If\n   `col_deriv is True, the transpose of this jac must be returned.\n\nrtol, atol : float, optional\n   The input parameters rtol and atol determine the error control\n   performed by the solver.  The solver will control the vector, e,\n   of estimated local errors in y, according to an inequality of\n   the form \"max-norm of (e / ewt) <= 1\", where ewt is a vector of\n   positive error weights computed as \"ewt = rtol * abs(y) + atol\".\n   rtol and atol can be either vectors the same length as y or\n   scalars. Defaults to 1.49012e-8.\n\ntcrit : ndarray, optional\n   Vector of critical points (e.g. singularities) where integration\n   care should be taken.\n\nh0 : float, (0: solver-determined), optional\n   The step size to be attempted on the first step.\n\nhmax : float, (0: solver-determined), optional\n   The maximum absolute step size allowed.\n\nhmin : float, (0: solver-determined), optional\n   The minimum absolute step size allowed.\n\nixpr : bool, optional\n   Whether to generate extra printing at method switches.\n\nmxstep : int, (0: solver-determined), optional\n   Maximum number of (internally defined) steps allowed for each\n   integration point in t.\n\nmxhnil : int, (0: solver-determined), optional\n   Maximum number of messages printed.\n\nmxordn : int, (0: solver-determined), optional\n   Maximum order to be allowed for the non-stiff (Adams) method.\n\nmxords : int, (0: solver-determined), optional\n   Maximum order to be allowed for the stiff (BDF) method.\n\node : a more object-oriented integrator based on VODE. quad : for\nfinding the area under a curve.\n\nThe second order differential equation for the angle theta of a\npendulum acted on by gravity with friction can be written:\n\n   theta''(t) + b*theta'(t) + c*sin(theta(t)) = 0\n\nwhere b and c are positive constants, and a prime (') denotes a\nderivative.  To solve this equation with odeint, we must first\nconvert it to a system of first order equations.  By defining the\nangular velocity \"omega(t) = theta'(t)\", we obtain the system:\n\n   theta'(t) = omega(t)\n   omega'(t) = -b*omega(t) - c*sin(theta(t))\n\nLet y be the vector [theta, omega].  We implement this system in\npython as:\n\n>>> def pend(y, t, b, c):\n...     theta, omega = y\n...     dydt = [omega, -b*omega - c*np.sin(theta)]\n...     return dydt\n...\n\nWe assume the constants are b = 0.25 and c = 5.0:\n\n>>> b = 0.25\n>>> c = 5.0\n\nFor initial conditions, we assume the pendulum is nearly vertical\nwith theta(0) = pi - 0.1, and it initially at rest, so omega(0) =\n0.  Then the vector of initial conditions is\n\n>>> y0 = [np.pi - 0.1, 0.0]\n\nWe generate a solution 101 evenly spaced samples in the interval 0\n<= t <= 10.  So our array of times is:\n\n>>> t = np.linspace(0, 10, 101)\n\nCall odeint to generate the solution.  To pass the parameters b and\nc to pend, we give them to odeint using the args argument.\n\n>>> from scipy.integrate import odeint\n>>> sol = odeint(pend, y0, t, args=(b, c))\n\nThe solution is an array with shape (101, 2).  The first column is\ntheta(t), and the second is omega(t).  The following code plots\nboth components.\n\n>>> import matplotlib.pyplot as plt\n>>> plt.plot(t, sol[:, 0], 'b', label='theta(t)')\n>>> plt.plot(t, sol[:, 1], 'g', label='omega(t)')\n>>> plt.legend(loc='best')\n>>> plt.xlabel('t')\n>>> plt.grid()\n>>> plt.show()"}}︡{"done":true}
︠c6da621d-6226-4b4b-b2e5-bc2a02d8d1cc︠
## What if we use the wrong gradient?

def gradient2(y, t):
    return [[0,t^2-t-1], [1,-t]]

y2 = odeint(func, y0, t, Dfun=gradient2)

y2[:36:6,1] ## Appears to affect the runtime, but not the solution.
︡51d98001-7343-41de-a0fb-9fe6a4cf6cc9︡{"stdout":"array([ 0.35502805,  0.33951138,  0.32406749,  0.30876306,  0.29365817,\n        0.27880648])\n"}︡{"done":true}
︠259d2045-574d-445a-8a6b-62cf7071b0e6i︠
%md

## Fourier transforms
︡0d82b94a-4d70-4d00-851f-cfe3197c91d9︡{"done":true,"md":"\n## Fourier transforms"}
︠816c9de2-bba3-48b6-84d6-76800c80290fi︠
%md
A one-dimensional discrete Fourier transform:

The FFT y[k] of length \(N\) of the length-\(N\) sequence $x[n]$ is defined as
\[y[k] = \sum_{n=0}^{N-1} e^{-2 \pi j \frac{k n}{N} } x[n] \, ,\]
and the inverse transform is defined as
\[x[n] = \frac{1}{N} \sum_{n=0}^{N-1} e^{2 \pi j \frac{k n}{N} } y[k] \, .\]

These transforms can be calculated by means of fft and ifft, respectively.
︡70a3e88a-79db-4b1c-9b8c-4cc53a73dee8︡{"done":true,"md":"A one-dimensional discrete Fourier transform:\n\nThe FFT y[k] of length \\(N\\) of the length-\\(N\\) sequence $x[n]$ is defined as\n\\[y[k] = \\sum_{n=0}^{N-1} e^{-2 \\pi j \\frac{k n}{N} } x[n] \\, ,\\]\nand the inverse transform is defined as\n\\[x[n] = \\frac{1}{N} \\sum_{n=0}^{N-1} e^{2 \\pi j \\frac{k n}{N} } y[k] \\, .\\]\n\nThese transforms can be calculated by means of fft and ifft, respectively."}
︠d1fc2ab4-8e26-4211-9852-06a817b20d77s︠
from scipy.fftpack import fft, ifft
x = np.array([1.0, 2.0, 1.0, -1.0, 1.5])
y = fft(x)
y
︡58524155-763b-45fd-b268-f36d4bb45f50︡{"stdout":"array([ 4.50000000+0.j        ,  2.08155948-1.65109876j,\n       -1.83155948+1.60822041j, -1.83155948-1.60822041j,\n        2.08155948+1.65109876j])\n"}︡{"done":true}
︠4a4dcc26-4072-4644-95eb-6dc465a55b25s︠
yinv = ifft(y)
yinv
︡00ccc58d-afbc-46ac-a702-349319ff6b00︡{"stdout":"array([ 1.0+0.j,  2.0+0.j,  1.0+0.j, -1.0+0.j,  1.5+0.j])\n"}︡{"done":true}
︠1be5b791-0d6f-416b-a8fa-946c32875c26i︠
%md
Consistency check: from the definitions, we must have
\[y[0] = \sum_{n=0}^{N-1} x[n] \, .\]
︡9b66d8f2-b4da-4b01-a3ec-646533bf0c33︡{"done":true,"md":"Consistency check: from the definitions, we must have\n\\[y[0] = \\sum_{n=0}^{N-1} x[n] \\, .\\]"}
︠9675ad78-93d9-475e-b67c-c915bb488758s︠
x.sum(), y[0]

︡db0411ad-5ff9-4cc1-8c04-34b00cd1d15b︡{"stdout":"(4.5, (4.5+0j))\n"}︡{"done":true}
︠54f7e0b8-e750-4a26-b0ef-bf320c0e37d3s︠
y.sum(), x[0]
︡15526c86-f9c9-48a9-9953-164a5472931c︡{"stdout":"((5+0j), 1.0)\n"}︡{"done":true}
︠a7a61c2c-bf0c-43cf-a5e2-623058d11bf0i︠
%md
One typical reason to perform a Fourier transform is to pick out periodic contributions to a signal (i.e., frequencies). Let's try this with a sum of two sine functions.

︡d27f883c-a406-401e-a52a-d64e2f443ed2︡{"done":true,"md":"One typical reason to perform a Fourier transform is to pick out periodic contributions to a signal (i.e., frequencies). Let's try this with a sum of two sine functions."}
︠ba2bacf2-3a1a-4400-a762-d1c7bf348110s︠
from scipy.fftpack import fft
# Number of sample points
N = 6000
# sample spacing
T = 1.0 / 800.0
x = np.linspace(0.0, N*T, N)
y = np.sin(50.0 * 2.0*np.pi*x) + 0.5*np.sin(80.0 * 2.0*np.pi*x)
yf = fft(y)
︡8130169b-3fc4-4d7c-98d4-0b04e30b5431︡{"done":true}
︠03fe00d6-3b9d-486f-998a-204be916573cs︠
xf = np.linspace(0.0, 1.0/(2.0*T), N/2)
import matplotlib.pyplot as plt
plt.plot(xf, 2.0/N * np.abs(yf[0:N/2]))
plt.grid()
plt.show()
︡a8369b3b-3929-42fe-b993-d4614f6199ac︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7fa9e2e73ad0>]\n"}︡{"file":{"filename":"d324ed80-c021-4dbe-921f-0dccb71d5bd8.svg","show":true,"uuid":"ddeb9e1b-2ea7-4c71-bd3b-cab7d753275b"},"once":false}︡{"done":true}
︠88e3107e-b527-46c1-b0bd-7a023cd7bb8bi︠
%md
## Signal processing: filters

︡26053864-09fd-41f1-bf7c-a80d625c154e︡{"done":true,"md":"## Signal processing: filters"}
︠e364ae24-c3e6-4950-b3c0-a6efb115f5f9i︠
%md

Here the basic ideal is that you have a "signal" consisting of a large array of numbers, but you only want to retain a smaller array that captures most of the essential information. A typical example is image processing. (The Snap IPO suggests there is big money in this!)
︡242ee3c4-7e36-464b-8928-ea053aeebf23︡{"done":true,"md":"\nHere the basic ideal is that you have a \"signal\" consisting of a large array of numbers, but you only want to retain a smaller array that captures most of the essential information. A typical example is image processing. (The Snap IPO suggests there is big money in this!)"}
︠7019ff24-6e59-4dcf-8e93-7c6b32e97b59︠

︡e3cbc5e9-5144-4ea7-acb2-33cba826bbf6︡{"code":{"lineno":-1,"mode":"text/x-rst","source":"File: /projects/sage/sage-7.5/local/lib/python2.7/site-packages/scipy/misc/common.py\nSignature : misc.lena()\nDocstring :\nFunction that previously returned an example image\n\nNote: Removed in 0.17\n\nNone\n\nNone\n\nRuntimeError\n   This functionality has been removed due to licensing reasons.\n\nThe image previously returned by this function has an incompatible\nlicense and has been removed from SciPy. Please use face or ascent\ninstead.\n\nface, ascent"}}︡{"done":true}
︠c9d71d4f-eb6d-4af0-9575-8aef65fa8166s︠
%python3 # This seems to work better in python3, not sure why.
from scipy import signal, misc
import matplotlib.pyplot as plt

image = misc.ascent()
plt.figure()
plt.imshow(image)
plt.gray()
plt.title('Original image')
plt.show()


︡6a84a911-41b4-4dc8-933a-7f404bdc7fba︡{"file":{"filename":"/tmp/tmpYtq4vc.png","show":true,"uuid":"0766aa95-06d1-4b45-85d8-37b00386bcb0"},"once":false}︡{"done":true}
︠a4351c16-8a5d-4fe8-88bd-eb609a62c4f8s︠
%python3
import numpy as np

w = np.zeros((50, 50))
w[0][0] = 1.0
w[49][25] = 1.0
image_new = signal.fftconvolve(image, w)

plt.figure()
plt.imshow(image_new)
plt.gray()
plt.title('Filtered image')
plt.show()
︡331fef9a-199d-4f72-9d36-b338c4d2f7fe︡{"file":{"filename":"/tmp/tmpwBAuDD.png","show":true,"uuid":"5c8985a6-7dcb-4e70-923b-6f941a75658b"},"once":false}︡{"done":true}
︠35b1eb0f-abd7-4f67-b2c2-a36eedef439cs︠
%python3
w = signal.gaussian(50, 10.0)
image_new = signal.sepfir2d(image, w, w)

plt.figure()
plt.imshow(image_new)
plt.gray()
plt.title('Filtered image')
plt.show()
︡a13c8484-ce85-471c-a27f-cdd55ee389ec︡{"file":{"filename":"/tmp/tmpw9zdq6.png","show":true,"uuid":"7a1acbf4-925f-4907-92fe-38fb998f912e"},"once":false}︡{"done":true}
︠9887c8bc-5876-4ecc-a163-424c80d64291s︠
%python3
image_new2 = signal.wiener(image_new)

plt.figure()
plt.imshow(image_new2)
plt.gray()
plt.title('Filtered image')
plt.show()
︡6a88609d-4dee-4ee2-b4ff-9e4eaf432c2d︡{"file":{"filename":"/tmp/tmpmPOnmi.png","show":true,"uuid":"ae9c412d-7c2c-45cd-913b-8f68dfa5c937"},"once":false}︡{"done":true}
︠bd941b1c-f03a-4893-8fcf-32e68c87ff31︠









